import java.awt.*;
import java.awt.event.*;
import java.applet.*;
/** 
  Foldable editor for 415.101FC assignment 9 Part B.
  @author Vincent Wing Hei, Ho
  @version 24.05.2000
*/

public class A9B extends Applet implements TextListener, ActionListener { 

   /** Collapse button */
    private Button collapse;
    /** Expand button */
    private Button expand;
    /** Textarea for user inputs */
    private TextArea input;
    /** Textarea for displaying processed output */
    private TextOutput output;
    /** Current mode, default = expand */
    private String mode = "EXPAND";
    /** Array for the line objects */
    private Line[] allLines;
    /** Number of Line, act as index for how many lines there is */    
    private int lineNumber = 0;
    
    /**
    Set the Applet up.
    Construct and position all of the components.
    */
    public void init () {
        setLayout(null);
        // constants for positioning components
        final int LEFT = 10;
        final int INPUT_TOP = 10;
        final int WIDTH = 580;
        final int INPUT_HEIGHT = 200;
        final int DISPLAY_TOP = 250;
        final int DISPLAY_HEIGHT = 340;
        final int COLLAPSE_LEFT = 50;
        final int EXPAND_LEFT = 120;
        final int BUTTON_TOP = 215;
        final int BUTTON_WIDTH = 60;
        final int BUTTON_HEIGHT = 30;
        
        input = new TextArea();
        input.setBounds(LEFT,INPUT_TOP,WIDTH,INPUT_HEIGHT);
        add(input);
        input.addTextListener(this);
        
        collapse = new Button("Collapse");
        collapse.setBounds(COLLAPSE_LEFT, BUTTON_TOP, BUTTON_WIDTH, BUTTON_HEIGHT);
        add(collapse);
        collapse.addActionListener(this);
        
        expand = new Button("Expand");
        expand.setBounds(EXPAND_LEFT, BUTTON_TOP, BUTTON_WIDTH, BUTTON_HEIGHT);
        add(expand);
        expand.addActionListener(this);

        output = new TextOutput();
        output.setBounds(LEFT, DISPLAY_TOP,WIDTH,DISPLAY_HEIGHT);

        ScrollPane scrollPane = new ScrollPane();
        scrollPane.add(output);
        scrollPane.setBounds(LEFT, DISPLAY_TOP,WIDTH,DISPLAY_HEIGHT);
        add(scrollPane);
    }
    
    /**
    Handles presses on buttons
    @param e Action Event
    */
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == collapse) {
            mode = "COLLAPSE";
            for (int i = 0; i < lineNumber; i++) {
                allLines[i].setFolded(true);
                allLines[i].setHidden(true);
            }
        }
        if (e.getSource() == expand) {
            mode = "EXPAND";
            for (int i = 0; i < lineNumber; i++) {
                allLines[i].setFolded(false);
                allLines[i].setHidden(false);
            }
        }
        outputDisplaying();
    }
    
    /**
    Handles text input in the input field
    @param e Text Event
    */
    public void textValueChanged(TextEvent e) {
        outputProcessing(input.getText());
    }
    
    /**
    Process output parsed from textValueChanged() method
    @param tempText content of the input field
    */
    public void outputProcessing(String tempText) {
        lineNumber = 0;        
        allLines = new Line[tempText.length()];
//        output.setText(""); 
        int lineEndPos;
        String nextLine;
        int level = 0;
        
        while (tempText.length() > 0) {
            lineEndPos = tempText.indexOf('\n');
            if (lineEndPos > -1) {
                nextLine = tempText.substring(0, lineEndPos);
                tempText = tempText.substring(lineEndPos + 1);
            }
            else {
                nextLine = tempText;
                tempText = "";
            }
            allLines[lineNumber] = new Line(nextLine, level);

            if (nextLine.indexOf("//{") != -1)
                level ++;

            if (nextLine.indexOf("//}") != -1 && level != 0)
                level --;

            lineNumber ++;
        }
        outputDisplaying();
    }
    
    /**
    Process the output of the display
    */
    public void outputDisplaying() {
        for (int i = 0; i < lineNumber; i++) {
//            allLines[i].display(output);
        }
    }
}