import java.awt.*;

/** 
 * A Line class for A9 415.101FC 2000
 * @author Vincent Wing Hei, Ho
 * @version 24.05.2000
 */
public class Line extends Object {
    /** Decide whether the line is displayed or not */
    boolean isFolded;
    /** Decide whether the line is hidden */
    boolean isHidden;
    /** Content of this line */
    String thisLine;
    /** Level of indentation */
    int level;

    /**
    Constructor method for the line object
    @param lineContent Content of a line
    @param lvl Level of indentations
    */
    public Line(String lineContent, int lvl) {
        isFolded = false;
        isHidden = false;
        level = lvl;
        thisLine = lineContent;
    }
    
    /**
    Output/Append the text as needed into TextArea
    @param o TextArea
    */
    public void display(TextArea o) {
        if (!isHidden) {
            if (thisLine.indexOf("//{") != -1) {
                int endAt = thisLine.indexOf("//{");
                if (isFolded)
                    o.append("> ");
                else
                    o.append("v ");
                indentation(o);
                o.append(thisLine.substring(endAt + 3) + '\n');
            }
            else if (thisLine.indexOf("//}") != -1) {
                int endAt = thisLine.indexOf("//}");
                o.append("  ");
                indentation(o);
                o.append(thisLine.substring(0,endAt) + '\n');
            }
            else {
                o.append("  ");
                indentation(o);
                o.append(thisLine + '\n');
            }
        }
    }
    
    /**
    Append spaces for indentations into output TextArea
    @param o TextArea
    */
    public void indentation(TextArea o) {
        for (int i = level; i >= 0; i--) {
            o.append("    ");
        }
    }
    
    /**
    Assign status of whether if this is a folded comment
    @param folded Boolean for folded or not
    */
    public void setFolded(boolean folded) {
        isFolded = folded;
    }
    
    /**
    Assign status of whether if this is a hided line
    @param hide Boolean for a line hided or not
    */
    public void setHidden(boolean hide) {
        isHidden = hide;
        if (level == 0)
            isHidden = false;
    }
}